#!/usr/bin/perl -w
# get packages summary and description from the file ARCHIVES
# for use with fou4s
# (c) Lars Ellenberg <l.g.e@web.de> Sep 2002

($PROG=$0) =~ s|^.*/||;
@ARGV == 1 or die "USAGE: $PROG package-base-name\n";

$ENV{ARCHIVES} ||= "./ARCHIVES";
$ARCHIVES=$ENV{ARCHIVES};

-e "$ARCHIVES" or die "$ARCHIVES not found\n";
-e "$ARCHIVES.idx" or
	system q{
		grep -b '^---> .*\.rpm *$' $ARCHIVES \
		| grep -v '\.src\.' \
		| sed 's/:---> .*\/\(.*\)\.rpm/'$'\t''\1/' > $ARCHIVES.idx
	};

# read the index in one gulp
open IDX,"$ARCHIVES.idx" or die "open $ARCHIVES.idx: $!\n";
undef $/; $_=<IDX>; close IDX; $/="\n";

/^(\d+)\t$ARGV[0]$/m 
or	# not in one line to avoid backtracing
/^(\d+)\t$ARGV[0]-[^-]+-[^-]+$/m;
$POS=$1;

die "'$ARGV[0]' not found in $ARCHIVES.idx\n" unless $POS;

open A,"$ARCHIVES" or die "cannot open $ARCHIVES: $!\n";
# if you know how to seek in bash, feel free to do it!
seek(A,$POS,0) or die "seek failed: $!\n";
$in_description = 0;
while(defined($_=<A>)) {
	last if /:    [dl-][rwx-]{9} /;
	$in_description=1
		if /:    (Summary     :|Description :|SuSE series:)/;
	if ($in_description) {
		last if /:    Authors:/;
		s/^.*?:    (.*?)\s*$/$1\n/;
		s/Summary     :\s*(.*?)\n/$1|/;
		print $_;
	}
}

__END__

# instead of grepping the pos again, we could read the *.idx in as a hash,
# and then access the positions this way.
# would be of benefit, if we have many queries.

open IDX,"$ARCHIVES.idx" or die "failed to open $ARCHIVES.idx: $!\n";
while(defined($_=<IDX>)) {
	if (/^(\d+)\t(\S+)$/) {
		$idx{$2}=$1;
	}
	else {
		warn "$ARCHIVES.idx:$.:unexpected line format $_";
	}
}
